
//  Tapahtumia.cs (c) 2005 Kari Laitinen

//  http://www.naturalprogramming.com

//  2005-01-25  Tiedosto luotu.
//  2005-01-25  Viimeisin muutos.

//  Kaannos: csc Tapahtumia.cs Paivamaara.cs

using System ;
using System.Collections ;

class  Tapahtuma  :  Paivamaara, IComparable
{
   protected string tapahtuman_kuvaus ;

   public Tapahtuma( int  tapahtuman_paiva,
                     int  tapahtuman_kuukausi,
                     int  tapahtuman_vuosi,
                     string annettu_tapahtuman_kuvaus )
   {
      tama_paiva     =  tapahtuman_paiva ;
      tama_kuukausi  =  tapahtuman_kuukausi ;
      tama_vuosi     =  tapahtuman_vuosi ;

      tapahtuman_kuvaus  =  annettu_tapahtuman_kuvaus ;
   }

   public override string ToString()
   {
      Paivamaara  tapahtuman_paivamaara  =  new  Paivamaara( tama_paiva,
                                                             tama_kuukausi,
                                                             tama_vuosi,
                                                   paivamaaran_formaatti ) ;

      return ( tapahtuman_paivamaara  +  "   "  +  tapahtuman_kuvaus ) ;
   }

   public int CompareTo( object olio_johon_verrataan )
   {
      Tapahtuma tapahtuma_johon_verrataan  = 
                            (Tapahtuma) olio_johon_verrataan ;

      int  vertailun_tulos  =  0 ;  //  Ovat saman paivayksen tapahtumia.

      if ( this.on_aikaisempi_kuin( tapahtuma_johon_verrataan ) )
      {
         vertailun_tulos  =  -1 ;   //  "tama" tapahtuma aikaisempi.
      }
      else if ( this.on_myohaisempi_kuin( tapahtuma_johon_verrataan ) )
      {
         vertailun_tulos  =  1 ;    //  "tama" tapahtuma myohempi.
      }

      return  vertailun_tulos ;
   }
}


class  Tapahtumia
{
   static void Main()
   {
      Tapahtuma  lennonin_syntyma   =  new  Tapahtuma(
                           9, 10, 1940, "John Lennon syntyi.") ;
      Tapahtuma  einsteinin_syntyma =  new  Tapahtuma(
                          14,  3, 1879, "Albert Einstein syntyi." ) ;

      ArrayList  tapahtumalista  =  new  ArrayList() ;

      tapahtumalista.Add( lennonin_syntyma ) ;
      tapahtumalista.Add( einsteinin_syntyma ) ;
      tapahtumalista.Add( new
          Tapahtuma( 8, 12, 1980, "John Lennon ammutiin New Yorkissa." ) ) ;

      Console.Write( "\nTapahtumat listalla tapahtumalista: \n" ) ;

      int tapahtuman_indeksi  =  0 ;

      while ( tapahtuman_indeksi  <  tapahtumalista.Count )
      {
         Console.Write( "\n   "  +  tapahtumalista[ tapahtuman_indeksi ] ) ;
         tapahtuman_indeksi  ++ ;
      }

      ArrayList  toinen_tapahtumalista  =  new  ArrayList() ;

      toinen_tapahtumalista.Insert( 0,
         new Tapahtuma(25, 6, 1941, "Jatkosota alkoi." ) ) ;
      toinen_tapahtumalista.Insert( 0,
         new Tapahtuma(13, 3, 1940, "Talvisota paattyi." ) ) ;
      toinen_tapahtumalista.Add(
         new Tapahtuma(10,10, 1834, "Aleksis Kivi syntyi." ) ) ;
      toinen_tapahtumalista.Add(
         new Tapahtuma( 8,12, 1865, "Jean Sibelius syntyi." ) ) ;


      Console.Write( "\n\nTapahtumat listalla toinen_tapahtumalista: \n" ) ;

      for ( tapahtuman_indeksi  =  0 ;
            tapahtuman_indeksi  <  toinen_tapahtumalista.Count ;
            tapahtuman_indeksi  ++ )
      {
         Console.Write( "\n   "
                     +  toinen_tapahtumalista[ tapahtuman_indeksi ] ) ;
      }

      tapahtumalista.Sort() ;
      toinen_tapahtumalista.Sort() ;

      tapahtumalista.InsertRange( 0, toinen_tapahtumalista ) ;

      Console.Write( "\n\nTapahtumat listalla tapahtumalista: \n" ) ;

      foreach ( Tapahtuma  tapahtuma_listalla  in  tapahtumalista )
      {
         Console.Write( "\n   "  +  tapahtuma_listalla ) ;
      }
   }
}





